generic-poky/meta/recipes-core/initscripts/initscripts-1.0/urandom
Richard Purdie 29d6678fd5 Major layout change to the packages directory
Having one monolithic packages directory makes it hard to find things
and is generally overwhelming. This commit splits it into several
logical sections roughly based on function, recipes.txt gives more
information about the classifications used.

The opportunity is also used to switch from "packages" to "recipes"
as used in OpenEmbedded as the term "packages" can be confusing to
people and has many different meanings.

Not all recipes have been classified yet, this is just a first pass
at separating things out. Some packages are moved to meta-extras as
they're no longer actively used or maintained.

Signed-off-by: Richard Purdie <rpurdie@linux.intel.com>
2010-08-27 15:29:45 +01:00

47 lines
1.3 KiB
Bash
Executable file

#! /bin/sh
### BEGIN INIT INFO
# Provides: urandom
# Required-Start: $local_fs mountvirtfs
# Required-Stop: $local_fs
# Default-Start: S
# Default-Stop: 0 6
# Short-Description: Save and restore the random seed
# Description: Save the random seed on shutdown and restore it on boot,
# to ensure that the seed isn't predicable on startup
# (because the boot process is predictable)
### END INIT INFO
test -c /dev/urandom || exit 0
. /etc/default/rcS
case "$1" in
start|"")
test "$VERBOSE" != no && echo "Initializing random number generator..."
# Load and then save 512 bytes,
# which is the size of the entropy pool
if test -f /var/lib/urandom/random-seed
then
cat /var/lib/urandom/random-seed >/dev/urandom
fi
rm -f /var/lib/urandom/random-seed
umask 077
dd if=/dev/urandom of=/var/lib/urandom/random-seed count=1 \
>/dev/null 2>&1 || echo "urandom start: failed."
umask 022
;;
stop)
# Carry a random seed from shut-down to start-up;
# see documentation in linux/drivers/char/random.c
test "$VERBOSE" != no && echo "Saving random seed..."
umask 077
dd if=/dev/urandom of=/var/lib/urandom/random-seed count=1 \
>/dev/null 2>&1 || echo "urandom stop: failed."
;;
*)
echo "Usage: urandom {start|stop}" >&2
exit 1
;;
esac
exit 0